<ui:composition
        xmlns:gzl="http://java.sun.com/jsf/composite/gazelle-tags"
        xmlns:f="http://java.sun.com/jsf/core"
        xmlns:rich="http://richfaces.org/rich"
        xmlns:a4j="http://richfaces.org/a4j"
        xmlns:ui="http://java.sun.com/jsf/facelets"
        xmlns:h="http://java.sun.com/jsf/html"
        xmlns="http://www.w3.org/1999/xhtml" template="/layout/template.xhtml">
    <ui:define name="body">
        <h:form id="globalform">
            <script type="text/javascript" src="https://www.google.com/jsapi"></script>
            <script type="text/javascript">
                google.load("visualization", "1", {packages:["corechart"]});
                google.setOnLoadCallback(drawAllCharts);

                function drawAllCharts()
                {
                    drawPieChart();
                    drawBarChartForIPs();
                    drawTimeLineYear();
                    drawTimeLineMonth();
                    drawColumnChart();
                }

                function drawColumnChart() {
                    var data = google.visualization.arrayToDataTable([
                        ['Validator', 'Validations requests']
                        <ui:repeat value="#{usageStatisticsManager.getResultsPerValidator()}" var="stat">
                            ,['#{stat[0]}',  #{stat[1]}]
                    </ui:repeat>
                ]);

                    var options = {
                        hAxis: {title: 'Validator',
                            textStyle: {fontSize:9},
                            slantedText: true,
                            slantedTextAngle: 45,
                            allowContainerBoundaryTextCufoff: false},
                        vAxis: {title: 'Number of validation requests',
                            logScale: true}
                    };

                    var chart = new google.visualization.ColumnChart(document.getElementById('columnDiv'));
                    chart.draw(data, options);
                    //var minichart = new google.visualization.ColumnChart(document.getElementById('minibarDiv'));
                    //minichart.draw(data,options);
                }


                function drawBarChartForIPs() {
                    var data = google.visualization.arrayToDataTable([
                        ['Caller IP', 'Validation requests']
                        <ui:repeat value="#{usageStatisticsManager.getStatisticsPerCallerIp()}" var="stat">
                            ,['#{stat[0]}',  #{stat[1]}]
                    </ui:repeat>
                ]);

                    var options = {
                        hAxis: {title: 'IP',
                            textStyle: {fontSize:9},
                            slantedText: true,
                            slantedTextAngle: 45},
                        vAxis: {title: 'Number of validation requests',
                            logScale:true}
                    };

                    var chart = new google.visualization.ColumnChart(document.getElementById('callerIpDiv'));
                    chart.draw(data, options);
                    google.visualization.events.addListener(chart, 'select', selectIPHandler);

                    function selectIPHandler(){
                        var row = chart.getSelection()[0].row;
                        var geoipURL = 'http://www.geoiptool.com/en/?IP=' + data.getValue(row, 0);
                        open(geoipURL, '_blank');
                    }
                    //var minichart = new google.visualization.ColumnChart(document.getElementById('miniCallerIpDiv'));
                    //minichart.draw(data, options);
                }

                function drawPieChart() {
                    var data = google.visualization.arrayToDataTable([
                        ['Status', 'percentage']
                        <ui:repeat value="#{usageStatisticsManager.getStatisticsPerResultStatus()}" var="stat">
                            ,['#{stat[0]}',  #{stat[1]}]
                    </ui:repeat>
                ]);

                    var options = {
                        slices: {0: {color: 'red'}, 1: {color: 'green'}}
                    };

                    var chart = new google.visualization.PieChart(document.getElementById('repartitionDiv'));
                    chart.draw(data, options);
                    //var minichart = new google.visualization.PieChart(document.getElementById('miniRepartitionDiv'));
                    //minichart.draw(data, options);
                }

                function drawTimeLineYear(){
                    var data = google.visualization.arrayToDataTable([
                        ['Period', 'Number of validations']
                        <ui:repeat value="#{usageStatisticsManager.getStatisticsPerDate(1)}" var="stat">
                            ,['#{stat[0]}',  #{stat[1]}]
                    </ui:repeat>
                ]);

                    var options = {
                        hAxis: {title: 'Period of time (years)', textStyle: {fontSize:9}},
                        vAxis: {title: 'Number of validation requests'},
                        pointSize: 3
                    };
                    var chartYear = new google.visualization.LineChart(document.getElementById('timeline_year'));
                    chartYear.draw(data, options);
                }

                function drawTimeLineMonth(){
                    var data = google.visualization.arrayToDataTable([
                        ['Period', 'Number of validations']
                        <ui:repeat value="#{usageStatisticsManager.getStatisticsPerDate(2)}" var="stat">
                            ,['#{stat[0]}',  #{stat[1]}]
                    </ui:repeat>
                ]);

                    var options = {
                        hAxis: {title: 'Period of time (months)', textStyle: {fontSize:9}},
                        vAxis: {title: 'Number of validation requests'},
                        pointSize: 3
                    };
                    var chartYear = new google.visualization.LineChart(document.getElementById('timeline_month'));
                    chartYear.draw(data, options);
                }
            </script>
            <h1>Statistics</h1>
            <gzl:div id="globalDiv">
                <ui:decorate template="/layout/panels/_panel_title_footer.xhtml">
                    <ui:param name="panel_id" value="searchCritieria"/>
                    <ui:define name="panel_title">
                        <h:outputText value="#{messages['validator.statistics.StatisticsCriteria']}"/>
                        <span class="pull-right">
                        <a4j:commandLink title="#{messages['validator.statistics.ResetCriteria']}"
                                         action="#{usageStatisticsManager.reset()}"
                                         oncomplete="drawAllCharts();"
                                         render="globalForm">
                            <span class="fa fa-times-circle"></span>
                        </a4j:commandLink>
                        </span>
                    </ui:define>

                    <h2>#{messages['validator.statistics.Period']}</h2>

                    <!--<ui:include src="/filter/filterDate.xhtml">-->
                    <!--<ui:param name="form_template" value="/layout/form/_edit.xhtml"/>-->
                    <!--<ui:param name="filter" value="#{browserBean.filter}"/>-->
                    <!--<ui:param name="filterId" value="timestamp"/>-->
                    <!--<ui:param name="filterName" value="#{messages['net.ihe.gazelle.proxy.Timestamp']}"/>-->
                    <!--<ui:param name="filterForm" value="browserform"/>-->
                    <!--</ui:include>-->

                    <div class="row">
                        <div class="col-lg-3">
                            <ui:decorate template="/layout/form/_edit.xhtml">
                                <ui:define name="label">#{messages['validator.statistics.From']}</ui:define>
                                <a4j:outputPanel id="fromdate" layout="block">
                                    <rich:calendar value="#{usageStatisticsManager.startDate}"
                                                   locale="#{localeSelector.localeString}" datePattern="yyyy/MM/dd"
                                                   showApplyButton="false">
                                    </rich:calendar>
                                </a4j:outputPanel>
                            </ui:decorate>
                        </div>
                        <div class="col-lg-3">
                            <ui:decorate template="/layout/form/_edit.xhtml">
                                <ui:define name="label">#{messages['validator.statistics.To']}</ui:define>
                                <a4j:outputPanel id="todate" layout="block">
                                    <rich:calendar value="#{usageStatisticsManager.endDate}"
                                                   locale="#{localeSelector.localeString}" datePattern="yyyy/MM/dd"
                                                   showApplyButton="false">
                                    </rich:calendar>
                                </a4j:outputPanel>
                            </ui:decorate>
                        </div>
                    </div>

                    <gzl:div id="IPSelectionPanel">
                        <h2>#{messages['validator.statistics.IncludeExcludeIPRange']}</h2>
                        <ui:decorate template="/layout/form/_edit.xhtml">
                            <h:selectOneRadio value="#{usageStatisticsManager.ipFilter}" layout="pageDirection">
                                <f:selectItem itemLabel="#{messages['validator.statistics.NoFilter']}"
                                              itemValue="#{usageStatisticsManager.ALL}"/>
                                <f:selectItem itemLabel="#{messages['validator.statistics.IncludeIPStartingWith']}"
                                              itemValue="#{usageStatisticsManager.INCLUDE}"/>
                                <f:selectItem itemLabel="#{messages['validator.statistics.ExcludeIPStartingWith']}"
                                              itemValue="#{usageStatisticsManager.EXCLUDE}"/>
                                <a4j:ajax event="change" render="ipStartsWithLabel"/>
                            </h:selectOneRadio>
                        </ui:decorate>
                        <gzl:div id="ipStartsWithLabel">
                            <ui:decorate template="/layout/form/_edit.xhtml">
                                <ui:param name="id" value="ipStartsWithId"/>
                                <ui:define name="label">
                                    IP Starts with
                                </ui:define>
                                <h:inputText id="ipStartsWithId" value="#{usageStatisticsManager.ipStartsWith}"
                                             rendered="#{not usageStatisticsManager.ipFilter.equals(usageStatisticsManager.ALL)}"
                                             styleClass="form-control"/>
                            </ui:decorate>
                        </gzl:div>
                    </gzl:div>
                    <ui:define name="panel_footer">
                        <a4j:commandButton
                                value="#{messages['validator.statistics.ComputeStatistics']}"
                                onclick="#{rich:component('panelLoading')}.show();"
                                oncomplete="#{rich:component('panelLoading')}.hide();drawAllCharts();"
                                render="globalform"
                                styleClass="gzl-btn-blue"/>
                    </ui:define>
                </ui:decorate>


                <ui:decorate template="/layout/panels/_panel_title.xhtml">
                    <ui:define name="panel_title">
                        #{messages['validator.statistics.ChartsOverview']}
                    </ui:define>

                    <div class="row">
                        <gzl:div id="miniBarDiv" styleClass="col-lg-2">
                            <a href="#columnchart1">
                                <img src="../img/columnchart1.gif"/>
                            </a>
                            <h:outputText value="#{messages['validator.statistics.RepartitionPerValidationType']}"/>
                        </gzl:div>
                        <gzl:div id="miniRepartitionDiv" styleClass="col-lg-2">
                            <a href="#piechart">
                                <img src="../img/piechart.gif"/>
                            </a>
                            <h:outputText value="#{messages['validator.statistics.RepartitionPerResult']}"/>
                        </gzl:div>
                        <gzl:div id="miniCallerIpDiv" styleClass="col-lg-2">
                            <a href="#columnchart2">
                                <img src="../img/columnchart2.gif"/>
                            </a>
                            <h:outputText value="#{messages['validator.statistics.RepartitionPerIP']}"/>
                        </gzl:div>
                        <gzl:div id="miniTimelineDiv" styleClass="col-lg-2">
                            <a href="#timelinemonth">
                                <img src="../img/timelinemonth.gif"/>
                            </a>
                            <h:outputText value="#{messages['validator.statistics.Timelinemonth']}"/>
                        </gzl:div>
                        <gzl:div id="miniTimelineDiv2" styleClass="col-lg-2">
                            <a href="#timelineyear">
                                <img src="../img/timelineyear.gif"/>
                            </a>
                            <h:outputText value="#{messages['validator.statistics.Timelineyear']}"/>
                        </gzl:div>
                    </div>
                </ui:decorate>

                <ui:decorate template="/layout/panels/_panel_title.xhtml">
                    <ui:define name="panel_title">
                        #{messages['validator.statistics.NumberOfValidationRequestsPerValidatorType']}
                    </ui:define>
                    <a name="columnchart1"/>
                    <div id="columnDiv" style="width: 900px; height: 500px;"/>
                </ui:decorate>

                <ui:decorate template="/layout/panels/_panel_title.xhtml">
                    <ui:define name="panel_title">
                        #{messages['validator.statistics.RepartitionOfValidationOutcomes']}
                    </ui:define>
                    <a name="piechart"/>
                    <div id="repartitionDiv" style="width: 900px; height: 500px;"/>
                </ui:decorate>

                <ui:decorate template="/layout/panels/_panel_title.xhtml">
                    <ui:define name="panel_title">
                        #{messages['validator.statistics.RepartitionOfValidationByCallersIP']}
                    </ui:define>
                    <a name="columnchart2"/>
                    <div id="callerIpDiv" style="width: 900px; height: 500px;"/>
                </ui:decorate>

                <ui:decorate template="/layout/panels/_panel_title.xhtml">
                    <ui:define name="panel_title">
                        #{messages['validator.statistics.Timelinemonth']}
                    </ui:define>
                    <a name="timelinemonth"/>
                    <div id="timeline_month" style="width: 900px; height: 500px;"/>
                </ui:decorate>

                <ui:decorate template="/layout/panels/_panel_title.xhtml">
                    <ui:define name="panel_title">
                        #{messages['validator.statistics.Timelineyear']}
                    </ui:define>
                    <a name="timelineyear"/>
                    <div id="timeline_year" style="width: 900px; height: 500px;"/>
                </ui:decorate>
            </gzl:div>
        </h:form>
    </ui:define>
</ui:composition>